angular.module('tombola-app.controllers').controller('TabelloneCtrl', function($scope, $location, $window) {
    $scope.pageClass = "page-tabellone";
    
    $scope.numeriDaEstrarre = [];
    $scope.numeriEstratti = [];
    $scope.caselle = [];
    $scope.ultimoEstratto;
    
    $scope.estrai = function() {
        var estratto = $scope.numeriDaEstrarre.pop();
        $scope.numeriEstratti.push(estratto);
        $scope.ultimoEstratto = estratto;
        
        var tabelloneState = {};
        
        tabelloneState.numeriDaEstrarre = $scope.numeriDaEstrarre;
        tabelloneState.numeriEstratti = $scope.numeriEstratti;
        tabelloneState.ultimoEstratto = $scope.ultimoEstratto;
        
        localStorage.setItem("tabelloneState", JSON.stringify(tabelloneState));
    };
    
    $scope.isEstratto= function(numeroCasella) {
        return $scope.numeriEstratti.indexOf(numeroCasella) != -1;   
    };
    
    $scope.ricomincia = function() {
        if (confirm('Sei sicuro?')) {
            localStorage.removeItem("tabelloneState");
            init();    
        }
    };
    
   var init = function() {
       if (localStorage.getItem('tabelloneState')) {
            var tabelloneState = JSON.parse(localStorage.getItem('tabelloneState'));
            $scope.numeriDaEstrarre = tabelloneState.numeriDaEstrarre;
            $scope.numeriEstratti = tabelloneState.numeriEstratti;
            $scope.ultimoEstratto = tabelloneState.ultimoEstratto;
       } else {
            $scope.ultimoEstratto = undefined;
            $scope.numeriEstratti = [];
            $scope.numeriDaEstrarre = [];
            for (var i = 1; i <= 90; i++) {
                $scope.numeriDaEstrarre.push(i);
            }
           $scope.numeriDaEstrarre = shuffle($scope.numeriDaEstrarre);
       }

        $scope.caselle = [];
        for (var i = 1; i <= 90; i++) {
            $scope.caselle.push(i);
        }
        
    };
    
    var shuffle = function(o){ //v1.0
        for(var j, x, i = o.length; i; j = Math.floor(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
        return o;
    };
    
    init();
});